; 
; Quick and dirty.
; 
    .model small,c
    .486
    .stack

    include support.asm

.data
    LFN_FILE_INFO STRUCT
      attributes      dd 0
      dosCreationTime dw 0
      dosCreationDate dw 0
      unused1         dd 0 ; Used for Windows 9x 64-bit format
      dosAccessTime   dw 0
      dosAccessDate   dw 0
      unused2         dd 0 ; Used for Windows 9x 64-bit format
      dosWriteTime    dw 0
      dosWriteDate    dw 0
      unused3         dd 0 ; Used for Windows 9x 64-bit format
      fileSizeHigh    dd 0
      fileSizeLow     dd 0
      reserved        db 8 dup(0)
      longNameZ       db 260 dup(0)
      shortNameZ      db 14 dup(0)
    LFN_FILE_INFO ENDS

    fi LFN_FILE_INFO    <>

    fileFindHandle      dw 0      
    requiredAttributes  db 0  ; normal
    allowedAttributes   db 0  ; normal
.code
.startup
;     
    mov   bx,81h              ; skip leading space
    .WHILE al != 13           ; scan command line for CR
      inc   bx
      mov   al,es:[bx]
    .ENDW    
    mov   BYTE PTR es:[bx],0  ; replace with null

    push  ds
    push  es

    mov   ax,ds
    push  es
    pop   ds
    mov   es,ax

    mov   ax,714Eh            ; LfnFindFirstFile
    mov   ch,es:requiredAttributes
    mov   cl,es:allowedAttributes
    mov   dx,82h              ; ds:dx -> filespec
    mov   di,OFFSET fi        ; es:di -> fi
    mov   si,1                ; specify DOS date/time values
    stc
    int   21h

    pop   es
    pop   ds
    
    .IF CARRY?
      .IF ax == 7100h
        print "not supported",NL
        jmp   fini
      .ELSE
        print "unexpected error",NL
        jmp   fini
      .ENDIF
    .ELSE    
      mov   fileFindHandle,ax
    .ENDIF

    print "long name = ",ADDR fi.longNameZ,NL
    print "short name = ",ADDR fi.shortNameZ,NL
    
    mov   ax,71A1h            ; LfnFindClose
    mov   bx,fileFindHandle
    int   21h
  fini:
    print NL,"Press any normal key to exit...",NL
    call waitkey
; 
.exit
end
